;Anscheinend hlt Windows (64bit) die 8 KByte IOPM in jedem TSS bereit.
;Daher gengt es, den Limit-Wert in der GDT entsprechend zu ndern.

.code
extern KdDebuggerNotPresent:qword	;Zeiger auf Byte

;void EachProcessorDpc(KDPC*Dpc, PVOID Context, PVOID Arg1, PVOID Arg2)
EachProcessorDpc proc
	push	r9			;Arg2 = Zeiger auf Affinittsmaske
	 mov	rcx,r8			;Arg1 = Argument
	 call	rdx			;Context = Prozedurzeiger
	pop	rcx
	movzx	eax,byte ptr gs:[184h]	;KeGetCurrentProcessorNumber() fr AMD64
	lock btr dword ptr[rcx],eax	;Fr diesen Prozessor als erledigt markieren
	ret
EachProcessorDpc endp

;Zeiger in GDT fr TSS beschaffen ->RAX
GetTssDesc proc private
	sub	rsp,16
	sgdt	[rsp+6]
	str	rax		;Windows: 0x40
	add	rax,[rsp+8]
	add	rsp,16
	ret
GetTssDesc endp

;GDT-Eintrag fr aktuellen TSS auslesen, Offset->RAX, Lnge->ECX
;Typischer Aufbau: 00700067 05008B3F FFFF8000 00000000
;Anscheinend reserviert Windows (Vista/7/8) bereits 8K Platz, da sind Nullen drin.
;Daher wrde es gengen, einfach das Limit in der GDT (den GDTs) zu erhhen.
;Bei Windows10 geht der Ansatz allerdings in die Hose:
;Ein Teil des Speichers ist nicht prsent.
GetTSS proc
	call	GetTssDesc
	xchg	rcx,rax
	mov	eax,[rcx+8]
	shl	rax,16
	mov	ah,[rcx+7]
	mov	al,[rcx+4]
	shl	rax,16
	mov	ax,[rcx+2]
;	movzx	ecx,word ptr[rcx]	;Lnge (fr ein TSS gengt das)
;	inc	ecx
	ret
GetTSS endp

;GDT-Eintrag fr aktuellen TSS ndern, Offset=RDX, Lnge=CX
SetTSS proc
	call	GetTssDesc
	mov	r8,[rax+8]
	mov	r9,[rax]
	dec	ecx
	mov	[rax],cx
	mov	[rax+2],dx
	shr	rdx,16
	mov	[rax+4],dl
	mov	[rax+7],dh
	shr	rdx,16
	mov	[rax+8],edx
	str	edx
	and	byte ptr[rax+5],not 2	;Busy-Bit in GDT lschen (sonst kracht's beim nchsten Befehl)
	ltr	dx			;Lade CPU-internen Cache des Task-Registers
;	 mov	rdx,qword ptr[KdDebuggerNotPresent]
;	 cmp	byte ptr[rdx],0
;	 jz	@f			;Springe wenn Debugger vorhanden
;	 mov	byte ptr[rax+1],0	;Das geht wirklich! PatchGuard austricksen
;@@
	mov	[rax],r9	;GDT restaurieren (beit sich mit Kernel-Debugger, nicht schlimm)
	mov	[rax+8],r8
	ret
SetTSS endp

RevertTSS proc
	call	GetTssDesc
	str	edx
	and	byte ptr[rax+5],not 2	;Busy-Bit in GDT lschen
	ltr	dx
	ret
RevertTSS endp

_movsq proc
	xchg	rdi,rdx
	xchg	rsi,r8
	rep movsq
	xchg	rsi,r8
	xchg	rdi,rdx
	ret
_movsq endp

end
